---
categories: OpenBSD, mail
title: Howto OpenSMTPD
...

* Documentation : <https://www.opensmtpd.org/>
* Rôle Ansible : <https://forge.evolix.org/projects/ansible-roles/repository/show/foo>
* Man pages : <https://man.openbsd.org/smtpd>

OpenSMTPD est un serveur mail intégré dans OpenBSD. Il est toutefois
disponible aussi sur Debian. Il comporte un nombre de fonctionnalités
réduites qui ne le permettent pas de tout faire mais il convient dans
la très grande majorité des cas. Sa syntaxe se veut similaire à celle
de pf.

## Installation sous Debian

~~~
# apt install opensmtpd

~~~

## Configuration de base

Sous OpenBSD, la configuration se trouve dans `/etc/mail/smtpd.conf`.

Cette configuration permet de relayer juste les mails qui viennent de
la machine elle-même. Il n'y a donc pas de risque d'être un relais
ouvert.

~~~
#       $OpenBSD: smtpd.conf,v 1.9 2016/05/03 18:43:45 jung Exp $

# This is the smtpd server system-wide configuration file.
# See smtpd.conf(5) for more information.

table aliases file:/etc/mail/aliases

# To accept external mail, replace with: listen on all
#
listen on lo0

# Uncomment the following to accept external mail for domain "example.org"
#
# accept from any for domain "example.org" alias <aliases> deliver to mbox
accept for local alias <aliases> deliver to mbox
accept from local for any relay

~~~

## Configurations spécifiques

### Réécrire le From: pour tous les mails

On a ce cas quand on veut que les mails de root soient avec un autre
nom de domaine que le hostname.

~~~
accept from local for any relay as "root@example.com"
~~~

### Bypasser un blocage du port 25

Il suffit de préciser dans la configuration de base le serveur par
lequel les mais vont passer avec le mot clé `via`.


~~~
accept from local for any relay via 192.0.2.25:2525
~~~

Bien sûr il faut que sur cette machine, le serveur mail écoute sur le
port donné et soit configurer pour relayer les mails depuis notre
machine. Il faudra aussi doute ouvrir le port dans le firewall.

## Commandes smtpctl pratiques

### Obtenir des stats

~~~
# smtpctl show stats
~~~ 

### Obtenir rapidement la taille de la mailq

~~~
# smtpctl show stats | grep  scheduler.envelope
~~~

### Voir la queue (équivalent de la commande `mailq`)

~~~
# smtpctl show queue
~~~

### Obtenir des détails sur un mail dans la queue 

~~~
# smtpctl show message 025a5c7b6cc771cb
~~~

### Forcer la redistribution de la queue

~~~
# smtpctl schedule all
~~~

### Supprimer tous les mails dans la queue

~~~
# smtpctl remove all
~~~
